package com.sun.corba.se.impl.orbutil;

import java.io.IOException;
import java.io.StringWriter;
import java.io.OutputStream;

public class HexOutputStream extends OutputStream
{
    private static final char[] hex;
    private StringWriter writer;
    
    public HexOutputStream(StringWriter writer) {
        this.writer = writer;
    }
    
    @Override
    public synchronized void write(int n) throws IOException {
        this.writer.write((int)HexOutputStream.hex[n >> 4 & 0xF]);
        this.writer.write((int)HexOutputStream.hex[n >> 0 & 0xF]);
    }
    
    @Override
    public synchronized void write(byte[] array) throws IOException {
        this.write(array, 0, array.length);
    }
    
    @Override
    public synchronized void write(byte[] array, int n, int n2) throws IOException {
        for (int i = 0; i < n2; ++i) {
            this.write((int)array[n + i]);
        }
    }
    
    static {
        hex = new char[] { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f' };
    }
}
